diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java b/src/main/java/net/minecraft/core/item/block/LeavesLayerBlockItem.java
similarity index 70%
rename from src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
rename to src/main/java/net/minecraft/core/item/block/LeavesLayerBlockItem.java
index 22bd7337f..8d69ece0b 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
+++ b/src/main/java/net/minecraft/core/item/block/LeavesLayerBlockItem.java
@@ -2,14 +2,13 @@
 package net.minecraft.core.item.block;
 
 
-import net.minecraft.core.Global;
+import net.minecraft.core.block.BaseLeavesBlock;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFluid;
-import net.minecraft.core.block.BlockLayerBase;
-import net.minecraft.core.block.BlockLayerLeaves;
-import net.minecraft.core.block.BlockLeavesBase;
+import net.minecraft.core.block.FluidBlock;
+import net.minecraft.core.block.BaseLayerBlock;
+import net.minecraft.core.block.LeavesLayerBlock;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
@@ -18,15 +17,15 @@ import net.minecraft.core.world.World;
 
 import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
 
-public class ItemBlockLayerLeaves extends ItemBlock
+public class LeavesLayerBlockItem extends BlockItem
 {
-	public ItemBlockLayerLeaves(Block block)
+	public LeavesLayerBlockItem(Block block)
 	{
 		super(block);
 	}
 
 	@Override
-	public boolean onUseItemOnBlock(final ItemStack itemstack, final EntityPlayer entityplayer, final World world, int blockX, int blockY, int blockZ, final Side side, double xPlaced, final double yPlaced)
+	public boolean onUseItemOnBlock(final ItemStack itemstack, final Player entityplayer, final World world, int blockX, int blockY, int blockZ, final Side side, double xPlaced, final double yPlaced)
 	{
 		int id = world.getBlockId(blockX, blockY, blockZ);
 		int meta = world.getBlockMetadata(blockX, blockY, blockZ);
@@ -48,11 +47,11 @@ public class ItemBlockLayerLeaves extends ItemBlock
 		if (id == blockID && side == Side.TOP)
 		{
 
-			final BlockLayerBase blockLayer = (BlockLayerBase) Block.blocksList[blockID];
+			final BaseLayerBlock blockLayer = (BaseLayerBlock) Block.blocksList[blockID];
 
 			final int newMeta = meta + 1;
 
-			final AABB bbBox = AABB.getBoundingBoxFromPool(blockX, blockY, blockZ, blockX + 1f, blockY + (2 * (newMeta + 1)) / 16.0f, blockZ + 1f);
+			final AABB bbBox = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX + 1f, blockY + (2 * (newMeta + 1)) / 16.0f, blockZ + 1f);
 			if (!world.checkIfAABBIsClear(bbBox))
 			{
 				return false;
@@ -60,17 +59,17 @@ public class ItemBlockLayerLeaves extends ItemBlock
 
 			if ((newMeta & 0b00001111) < 7)
 			{
-				world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, BlockLayerLeaves.setPermanent(newMeta, true));
+				world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, LeavesLayerBlock.setPermanent(newMeta, true));
 			}
 			else
 			{
 				if (blockLayer.fullBlockID != -1)
 				{
-					world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockLayer.fullBlockID, BlockLeavesBase.setPermanent(0, true));
+					world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockLayer.fullBlockID, BaseLeavesBlock.setPermanent(0, true));
 				}
 				else
 				{
-					world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, blockID, BlockLayerLeaves.setPermanent(0, true));
+					world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, blockID, LeavesLayerBlock.setPermanent(0, true));
 				}
 			}
 			world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockLayer, EnumBlockSoundEffectType.PLACE);
@@ -93,11 +92,11 @@ public class ItemBlockLayerLeaves extends ItemBlock
 		if (id == blockID)
 		{
 
-			final BlockLayerBase blockLayer = (BlockLayerBase) Block.blocksList[blockID];
+			final BaseLayerBlock blockLayer = (BaseLayerBlock) Block.blocksList[blockID];
 
 			final int newMeta = meta + 1;
 
-			final AABB bbBox = AABB.getBoundingBoxFromPool(blockX, blockY, blockZ, blockX + 1f, blockY + (2 * (newMeta + 1)) / 16.0f, blockZ + 1f);
+			final AABB bbBox = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX + 1f, blockY + (2 * (newMeta + 1)) / 16.0f, blockZ + 1f);
 			if (!world.checkIfAABBIsClear(bbBox))
 			{
 				return false;
@@ -105,17 +104,17 @@ public class ItemBlockLayerLeaves extends ItemBlock
 
 			if ((newMeta & 0b00001111) < 7)
 			{
-				world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, BlockLayerLeaves.setPermanent(newMeta, true));
+				world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, LeavesLayerBlock.setPermanent(newMeta, true));
 			}
 			else
 			{
 				if (blockLayer.fullBlockID != -1)
 				{
-					world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockLayer.fullBlockID, BlockLeavesBase.setPermanent(0, true));
+					world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockLayer.fullBlockID, BaseLeavesBlock.setPermanent(0, true));
 				}
 				else
 				{
-					world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, blockID, BlockLayerLeaves.setPermanent(0, true));
+					world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, blockID, LeavesLayerBlock.setPermanent(0, true));
 				}
 			}
 			world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockLayer, EnumBlockSoundEffectType.PLACE);
@@ -128,13 +127,13 @@ public class ItemBlockLayerLeaves extends ItemBlock
 		{
 			final Block block = Block.blocksList[blockID];
 			Block currentBlock = world.getBlock(blockX, blockY, blockZ);
-			boolean placedInside = currentBlock != null && !(currentBlock instanceof BlockFluid);
-			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, BlockLayerLeaves.setPermanent(getPlacedBlockMetadata(itemstack.getMetadata()), true)))
+			boolean placedInside = currentBlock != null && !(currentBlock instanceof FluidBlock);
+			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, LeavesLayerBlock.setPermanent(getPlacedBlockMetadata(itemstack.getMetadata()), true)))
 			{
 				if (placedInside && !world.isClientSide){
 					world.playSoundEffect(EVENT_BLOCK_BREAK, blockX, blockY, blockZ, currentBlock.id);
 				}
-				Block.blocksList[blockID].onBlockPlaced(world, blockX, blockY, blockZ, null, entityplayer, yPlaced);
+				Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, null, entityplayer, yPlaced);
 				world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
 				itemstack.consumeItem(entityplayer);
 			}
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockChestLegacy.java b/src/main/java/net/minecraft/core/item/block/LegacyChestBlockItem.java
similarity index 65%
rename from src/main/java/net/minecraft/core/item/block/ItemBlockChestLegacy.java
rename to src/main/java/net/minecraft/core/item/block/LegacyChestBlockItem.java
index b0bea6015..3bf3a0c9b 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockChestLegacy.java
+++ b/src/main/java/net/minecraft/core/item/block/LegacyChestBlockItem.java
@@ -3,9 +3,9 @@ package net.minecraft.core.item.block;
 import net.minecraft.core.block.Block;
 
 @Deprecated
-public class ItemBlockChestLegacy extends ItemBlock{
+public class LegacyChestBlockItem extends BlockItem {
 
-	public ItemBlockChestLegacy(Block block) {
+	public LegacyChestBlockItem(Block block) {
 		super(block);
 	}
 	
diff --git a/src/main/java/net/minecraft/core/item/block/PaintedBlockItem.java b/src/main/java/net/minecraft/core/item/block/PaintedBlockItem.java
new file mode 100644
index 000000000..2114d28ab
--- /dev/null
+++ b/src/main/java/net/minecraft/core/item/block/PaintedBlockItem.java
@@ -0,0 +1,44 @@
+package net.minecraft.core.item.block;
+
+
+// Referenced classes of package net.minecraft.src:
+//            BlockItem, Block, BlockCloth, DyeItem,
+//            ItemStack
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.WoolBlock;
+import net.minecraft.core.item.DyeItem;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.DyeColor;
+
+public class PaintedBlockItem extends BlockItem
+{
+	private final boolean upperMetadata;
+	
+    public PaintedBlockItem(Block block, boolean upperMetadata)
+    {
+        super(block);
+        setMaxDamage(0);
+        setHasSubtypes(true);
+        this.upperMetadata = upperMetadata;
+    }
+
+    @Override
+    public int getPlacedBlockMetadata(int i)
+    {
+        return i;
+    }
+
+    @Override
+    public String getLanguageKey(ItemStack itemstack)
+    {
+    	if (upperMetadata)
+    	{
+    		return super.getKey() + "." + DyeColor.colorFromBlockMeta((itemstack.getMetadata() & 0xF0) >> 4).colorID;
+    	}
+    	else
+    	{
+    		return super.getKey() + "." + DyeColor.colorFromBlockMeta(itemstack.getMetadata() & 0xF).colorID;
+    	}
+    }
+}
diff --git a/src/main/java/net/minecraft/core/item/block/PaintedSlabBlockItem.java b/src/main/java/net/minecraft/core/item/block/PaintedSlabBlockItem.java
new file mode 100644
index 000000000..072e58c9c
--- /dev/null
+++ b/src/main/java/net/minecraft/core/item/block/PaintedSlabBlockItem.java
@@ -0,0 +1,44 @@
+package net.minecraft.core.item.block;
+
+
+// Referenced classes of package net.minecraft.src:
+//            BlockItem, Block, BlockCloth, DyeItem,
+//            ItemStack
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.WoolBlock;
+import net.minecraft.core.item.DyeItem;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.DyeColor;
+
+public class PaintedSlabBlockItem extends SlabBlockItem
+{
+	private final boolean upperMetadata;
+	
+    public PaintedSlabBlockItem(Block block)
+    {
+        super(block);
+        setMaxDamage(0);
+        setHasSubtypes(true);
+        this.upperMetadata = true;
+    }
+
+    @Override
+    public int getPlacedBlockMetadata(int i)
+    {
+        return i;
+    }
+
+    @Override
+    public String getLanguageKey(ItemStack itemstack)
+    {
+        if (upperMetadata)
+        {
+            return super.getKey() + "." + DyeColor.colorFromBlockMeta((itemstack.getMetadata() & 0xF0) >> 4).colorID;
+        }
+        else
+        {
+            return super.getKey() + "." + DyeColor.colorFromBlockMeta(itemstack.getMetadata() & 0xF).colorID;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockPiston.java b/src/main/java/net/minecraft/core/item/block/PistonBlockItem.java
similarity index 70%
rename from src/main/java/net/minecraft/core/item/block/ItemBlockPiston.java
rename to src/main/java/net/minecraft/core/item/block/PistonBlockItem.java
index 34836bbaf..47d747497 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockPiston.java
+++ b/src/main/java/net/minecraft/core/item/block/PistonBlockItem.java
@@ -2,14 +2,14 @@ package net.minecraft.core.item.block;
 
 
 // Referenced classes of package net.minecraft.src:
-//            ItemBlock
+//            BlockItem
 
 import net.minecraft.core.block.Block;
 
-public class ItemBlockPiston extends ItemBlock
+public class PistonBlockItem extends BlockItem
 {
 
-    public ItemBlockPiston(Block block)
+    public PistonBlockItem(Block block)
     {
         super(block);
     }
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java b/src/main/java/net/minecraft/core/item/block/SlabBlockItem.java
similarity index 81%
rename from src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
rename to src/main/java/net/minecraft/core/item/block/SlabBlockItem.java
index f5f72bd45..741b98835 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
+++ b/src/main/java/net/minecraft/core/item/block/SlabBlockItem.java
@@ -1,10 +1,9 @@
 package net.minecraft.core.item.block;
 
-import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFluid;
+import net.minecraft.core.block.FluidBlock;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
@@ -12,22 +11,16 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 
 import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
-
-
-// Referenced classes of package net.minecraft.src:
-//            Item, Block, World, ItemStack, 
-//            Material, StepSound, EntityPlayer
-
-public class ItemBlockSlab extends ItemBlock
+public class SlabBlockItem extends BlockItem
 {
 
-    public ItemBlockSlab(Block block)
+    public SlabBlockItem(Block block)
     {
         super(block);
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
     	int id = world.getBlockId(blockX, blockY, blockZ);
     	int meta = world.getBlockMetadata(blockX, blockY, blockZ) & 0x3;
@@ -51,7 +44,7 @@ public class ItemBlockSlab extends ItemBlock
         {
         	if ((side == Side.TOP && meta == 0) || (side == Side.BOTTOM && meta == 2))
         	{
-                AABB bbBox = AABB.getBoundingBoxFromPool(blockX, blockY, blockZ, blockX +1f, blockY +1f, blockZ +1f);
+                AABB bbBox = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX +1f, blockY +1f, blockZ +1f);
                 if(!world.checkIfAABBIsClear(bbBox))
                     return false;
 
@@ -79,7 +72,7 @@ public class ItemBlockSlab extends ItemBlock
         {
         	if ((yPlaced > 0.5f && meta == 0) || (yPlaced <= 0.5f && meta == 2) || (side == Side.BOTTOM && meta == 0) || (side == Side.TOP && meta == 2))
         	{
-                AABB bbBox = AABB.getBoundingBoxFromPool(blockX, blockY, blockZ, blockX +1f, blockY +1f, blockZ +1f);
+                AABB bbBox = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX +1f, blockY +1f, blockZ +1f);
                 if(!world.checkIfAABBIsClear(bbBox))
                     return false;
 
@@ -96,13 +89,13 @@ public class ItemBlockSlab extends ItemBlock
         {
             Block block = Block.blocksList[blockID];
             Block currentBlock = world.getBlock(blockX, blockY, blockZ);
-            boolean placedInside = currentBlock != null && !(currentBlock instanceof BlockFluid);
+            boolean placedInside = currentBlock != null && !(currentBlock instanceof FluidBlock);
             if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, getPlacedBlockMetadata(itemstack.getMetadata())))
             {
                 if (placedInside && !world.isClientSide){
                     world.playSoundEffect(EVENT_BLOCK_BREAK, blockX, blockY, blockZ, currentBlock.id);
                 }
-            	Block.blocksList[blockID].onBlockPlaced(world, blockX, blockY, blockZ, side, entityplayer, yPlaced);
+            	Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, side, entityplayer, yPlaced);
                 world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
                 itemstack.consumeItem(entityplayer);
             }
diff --git a/src/main/java/net/minecraft/core/item/material/ArmorMaterial.java b/src/main/java/net/minecraft/core/item/material/ArmorMaterial.java
index 36e513964..d3dd6792a 100644
--- a/src/main/java/net/minecraft/core/item/material/ArmorMaterial.java
+++ b/src/main/java/net/minecraft/core/item/material/ArmorMaterial.java
@@ -27,13 +27,11 @@ public class ArmorMaterial {
 
 	public final NamespaceID identifier;
 	public final int durability;
-	public final int renderIndex;
 	
 	private final Map<DamageType, Float> protection = new HashMap<>();
 	
-	public ArmorMaterial(NamespaceID identifier, int renderIndex, int durability) {
+	public ArmorMaterial(NamespaceID identifier, int durability) {
 		this.identifier = identifier;
-		this.renderIndex = renderIndex;
 		this.durability = durability;
 
 		ARMOR_MATERIALS.add(this);
@@ -52,37 +50,37 @@ public class ArmorMaterial {
 		return this;
 	}
 	
-	public static final ArmorMaterial LEATHER = register(new ArmorMaterial(new NamespaceID("minecraft", "cloth"), 0, 180)
+	public static final ArmorMaterial LEATHER = register(new ArmorMaterial(new NamespaceID("minecraft", "cloth"), 180)
 		.withProtectionPercentage(COMBAT, 20.0f)
 		.withProtectionPercentage(BLAST, 20.0f)
 		.withProtectionPercentage(FIRE, 20.0f)
 		.withProtectionPercentage(FALL, 120.0f)
 	);
-	public static final ArmorMaterial CHAINMAIL = register(new ArmorMaterial(new NamespaceID("minecraft", "chain"), 1, 240)
+	public static final ArmorMaterial CHAINMAIL = register(new ArmorMaterial(new NamespaceID("minecraft", "chain"), 240)
 		.withProtectionPercentage(COMBAT, 120.0f)
 		.withProtectionPercentage(BLAST, 35.0f)
 		.withProtectionPercentage(FIRE, 35.0f)
 		.withProtectionPercentage(FALL, 35.0f)
 	);
-	public static final ArmorMaterial IRON = register(new ArmorMaterial(new NamespaceID("minecraft", "iron"), 2, 200)
+	public static final ArmorMaterial IRON = register(new ArmorMaterial(new NamespaceID("minecraft", "iron"), 200)
 		.withProtectionPercentage(COMBAT, 45.0f)
 		.withProtectionPercentage(BLAST, 45.0f)
 		.withProtectionPercentage(FIRE, 45.0f)
 		.withProtectionPercentage(FALL, 45.0f)
 	);
-	public static final ArmorMaterial GOLD = register(new ArmorMaterial(new NamespaceID("minecraft", "gold"), 4, 120)
+	public static final ArmorMaterial GOLD = register(new ArmorMaterial(new NamespaceID("minecraft", "gold"), 120)
 		.withProtectionPercentage(COMBAT, 70.0f)
 		.withProtectionPercentage(BLAST, 70.0f)
 		.withProtectionPercentage(FIRE, 70.0f)
 		.withProtectionPercentage(FALL, 70.0f)
 	);
-	public static final ArmorMaterial DIAMOND = register(new ArmorMaterial(new NamespaceID("minecraft", "diamond"), 3, 800)
+	public static final ArmorMaterial DIAMOND = register(new ArmorMaterial(new NamespaceID("minecraft", "diamond"), 800)
 		.withProtectionPercentage(COMBAT, 66.0f)
 		.withProtectionPercentage(BLAST, 66.0f)
 		.withProtectionPercentage(FIRE, 124.0f)
 		.withProtectionPercentage(FALL, 66.0f)
 	);
-	public static final ArmorMaterial STEEL = register(new ArmorMaterial(new NamespaceID("minecraft", "steel"), 5, 1200)
+	public static final ArmorMaterial STEEL = register(new ArmorMaterial(new NamespaceID("minecraft", "steel"), 1200)
 		.withProtectionPercentage(COMBAT, 55.0f)
 		.withProtectionPercentage(BLAST, 150.0f)
 		.withProtectionPercentage(FIRE, 55.0f)
diff --git a/src/main/java/net/minecraft/core/item/tag/ItemTags.java b/src/main/java/net/minecraft/core/item/tag/ItemTags.java
index 7114b752b..66e2e1847 100644
--- a/src/main/java/net/minecraft/core/item/tag/ItemTags.java
+++ b/src/main/java/net/minecraft/core/item/tag/ItemTags.java
@@ -2,6 +2,7 @@ package net.minecraft.core.item.tag;
 
 import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 
 import java.lang.reflect.Field;
 import java.util.ArrayList;
diff --git a/src/main/java/net/minecraft/core/item/tool/ItemToolAxe.java b/src/main/java/net/minecraft/core/item/tool/AxeToolItem.java
similarity index 61%
rename from src/main/java/net/minecraft/core/item/tool/ItemToolAxe.java
rename to src/main/java/net/minecraft/core/item/tool/AxeToolItem.java
index a5847e3f0..12ce33833 100644
--- a/src/main/java/net/minecraft/core/item/tool/ItemToolAxe.java
+++ b/src/main/java/net/minecraft/core/item/tool/AxeToolItem.java
@@ -1,37 +1,37 @@
 package net.minecraft.core.item.tool;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLog;
+import net.minecraft.core.block.LogBlock;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.data.gamerule.TreecapitatorHelper;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.material.ToolMaterial;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class ItemToolAxe extends ItemTool
+public class AxeToolItem extends ToolItem
 {
 
-    public ItemToolAxe(String name, int id, ToolMaterial enumtoolmaterial)
+    public AxeToolItem(String name, String namespaceId, int id, ToolMaterial enumtoolmaterial)
     {
-        super(name, id, 3, enumtoolmaterial, BlockTags.MINEABLE_BY_AXE);
+        super(name, namespaceId, id, 3, enumtoolmaterial, BlockTags.MINEABLE_BY_AXE);
     }
 
     @Override
-    public boolean canHarvestBlock(EntityLiving entityLiving, ItemStack itemStack, Block block)
+    public boolean canHarvestBlock(Mob entityLiving, ItemStack itemStack, Block block)
     {
         return block.hasTag(BlockTags.MINEABLE_BY_AXE);
     }
     
     @Override
-    public boolean beforeDestroyBlock(World world, ItemStack itemStack, int blockId, int x, int y, int z, Side side, EntityPlayer player)
+    public boolean beforeDestroyBlock(World world, ItemStack itemStack, int blockId, int x, int y, int z, Side side, Player player)
     {
     	if(!world.isClientSide && world.getGameRuleValue(GameRules.TREECAPITATOR) && !player.isSneaking()) {
     		int id = world.getBlockId(x, y, z);
-    		if(Block.getBlock(id) instanceof BlockLog) {
+    		if(Block.getBlock(id) instanceof LogBlock) {
             	return !new TreecapitatorHelper(world, x, y, z, player).chopTree();
     		}
     	}
diff --git a/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java b/src/main/java/net/minecraft/core/item/tool/HoeToolItem.java
similarity index 61%
rename from src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java
rename to src/main/java/net/minecraft/core/item/tool/HoeToolItem.java
index 24b69dcaa..293c65566 100644
--- a/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java
+++ b/src/main/java/net/minecraft/core/item/tool/HoeToolItem.java
@@ -1,11 +1,13 @@
 package net.minecraft.core.item.tool;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.material.ToolMaterial;
 import net.minecraft.core.util.helper.Side;
@@ -13,39 +15,39 @@ import net.minecraft.core.world.World;
 
 // Referenced classes of package net.minecraft.src:
 //            Item, EnumToolMaterial, World, Block, 
-//            BlockGrass, StepSound, ItemStack, EntityPlayer
+//            GrassBlock, StepSound, ItemStack, Player
 
-public class ItemToolHoe extends ItemTool
+public class HoeToolItem extends ToolItem
 {
-    public ItemToolHoe(String name, int id, ToolMaterial enumtoolmaterial)
+    public HoeToolItem(String name, String namespaceId, int id, ToolMaterial enumtoolmaterial)
     {
-        super(name, id, 3, enumtoolmaterial, BlockTags.MINEABLE_BY_HOE);
+        super(name, namespaceId, id, 3, enumtoolmaterial, BlockTags.MINEABLE_BY_HOE);
         maxStackSize = 1;
         setMaxDamage(enumtoolmaterial.getDurability());
     }
 
     @Override
-    public boolean canHarvestBlock(EntityLiving entityLiving, ItemStack itemStack, Block block)
+    public boolean canHarvestBlock(Mob entityLiving, ItemStack itemStack, Block block)
     {
         return block.hasTag(BlockTags.MINEABLE_BY_HOE);
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
         int id = world.getBlockId(blockX, blockY, blockZ);
         int j1 = world.getBlockId(blockX, blockY + 1, blockZ);
-        if(side != Side.BOTTOM && j1 == 0 && (id == Block.grass.id || id == Block.dirt.id || id == Block.pathDirt.id || id == Block.grassRetro.id || id == Block.mud.id))
+        if(side != Side.BOTTOM && j1 == 0 && (id == Blocks.GRASS.id || id == Blocks.DIRT.id || id == Blocks.PATH_DIRT.id || id == Blocks.GRASS_RETRO.id || id == Blocks.MUD.id))
         {
             int meta = 0;
-            if(id == Block.mud.id)
+            if(id == Blocks.MUD.id)
                 meta = 1;
-            Block block = Block.farmlandDirt;
-            world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Block.dirt, EnumBlockSoundEffectType.MINE);
+            Block block = Blocks.FARMLAND_DIRT;
+            world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.DIRT, EnumBlockSoundEffectType.MINE);
             if(!world.isClientSide) {
-                if(id == Block.grass.id || id == Block.grassRetro.id || id == Block.grassScorched.id) {
+                if(id == Blocks.GRASS.id || id == Blocks.GRASS_RETRO.id || id == Blocks.GRASS_SCORCHED.id) {
                 	if(world.rand.nextInt(5) == 0) {
-                		world.dropItem(blockX, blockY + 1, blockZ, new ItemStack(Item.seedsWheat));
+                		world.dropItem(blockX, blockY + 1, blockZ, new ItemStack(Items.SEEDS_WHEAT));
                 	}
                 }
             }
@@ -65,15 +67,15 @@ public class ItemToolHoe extends ItemTool
     }
     
     @Override
-    public boolean onBlockDestroyed(World world, ItemStack itemstack, int id, int x, int y, int z, Side side, EntityLiving entity) {
+    public boolean onBlockDestroyed(World world, ItemStack itemstack, int id, int x, int y, int z, Side side, Mob entity) {
     	if(entity != null && !entity.world.isClientSide) {
-        	if(id == Block.tallgrass.id || id == Block.tallgrassFern.id) {
+        	if(id == Blocks.TALLGRASS.id || id == Blocks.TALLGRASS_FERN.id) {
         		if(this.material.isSilkTouch()) {
         			entity.world.dropItem(x, y, z, new ItemStack(Item.itemsList[id]));
             		itemstack.damageItem(1, entity);
         		}else {
         			if(entity.world.rand.nextInt(4) == 0) {
-            			entity.world.dropItem(x, y, z, new ItemStack(Item.seedsWheat));
+            			entity.world.dropItem(x, y, z, new ItemStack(Items.SEEDS_WHEAT));
                 		itemstack.damageItem(1, entity);	
         			}
         		}
diff --git a/src/main/java/net/minecraft/core/item/tool/PickaxeToolItem.java b/src/main/java/net/minecraft/core/item/tool/PickaxeToolItem.java
new file mode 100644
index 000000000..9a78639d1
--- /dev/null
+++ b/src/main/java/net/minecraft/core/item/tool/PickaxeToolItem.java
@@ -0,0 +1,71 @@
+package net.minecraft.core.item.tool;
+
+import java.util.HashMap;
+import java.util.Map;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.material.ToolMaterial;
+
+public class PickaxeToolItem extends ToolItem {
+	
+	public static Map<Block, Integer> miningLevels = new HashMap<>();
+	
+	static {
+		miningLevels.put(Blocks.OBSIDIAN, 3);
+		
+		miningLevels.put(Blocks.BLOCK_DIAMOND, 2);
+		miningLevels.put(Blocks.ORE_DIAMOND_STONE, 2);
+		miningLevels.put(Blocks.ORE_DIAMOND_BASALT, 2);
+		miningLevels.put(Blocks.ORE_DIAMOND_GRANITE, 2);
+		miningLevels.put(Blocks.ORE_DIAMOND_LIMESTONE, 2);
+		
+		miningLevels.put(Blocks.BLOCK_GOLD, 2);
+		miningLevels.put(Blocks.ORE_GOLD_STONE, 2);
+		miningLevels.put(Blocks.ORE_GOLD_BASALT, 2);
+		miningLevels.put(Blocks.ORE_GOLD_GRANITE, 2);
+		miningLevels.put(Blocks.ORE_GOLD_LIMESTONE, 2);
+		
+		miningLevels.put(Blocks.BLOCK_IRON, 1);
+		miningLevels.put(Blocks.ORE_IRON_STONE, 1);
+		miningLevels.put(Blocks.ORE_IRON_BASALT, 1);
+		miningLevels.put(Blocks.ORE_IRON_GRANITE, 1);
+		miningLevels.put(Blocks.ORE_IRON_LIMESTONE, 1);
+		
+		miningLevels.put(Blocks.BLOCK_STEEL, 2);
+		
+		miningLevels.put(Blocks.ORE_NETHERCOAL_NETHERRACK, 2);
+		
+		miningLevels.put(Blocks.BLOCK_LAPIS, 1);
+		miningLevels.put(Blocks.ORE_LAPIS_STONE, 1);
+		miningLevels.put(Blocks.ORE_LAPIS_BASALT, 1);
+		miningLevels.put(Blocks.ORE_LAPIS_GRANITE, 1);
+		miningLevels.put(Blocks.ORE_LAPIS_LIMESTONE, 1);
+		
+		miningLevels.put(Blocks.BLOCK_REDSTONE, 2);
+		miningLevels.put(Blocks.ORE_REDSTONE_STONE, 2);
+		miningLevels.put(Blocks.ORE_REDSTONE_BASALT, 2);
+		miningLevels.put(Blocks.ORE_REDSTONE_GRANITE, 2);
+		miningLevels.put(Blocks.ORE_REDSTONE_LIMESTONE, 2);
+		miningLevels.put(Blocks.ORE_REDSTONE_GLOWING_STONE, 2);
+		miningLevels.put(Blocks.ORE_REDSTONE_GLOWING_BASALT, 2);
+		miningLevels.put(Blocks.ORE_REDSTONE_GLOWING_GRANITE, 2);
+		miningLevels.put(Blocks.ORE_REDSTONE_GLOWING_LIMESTONE, 2);
+	}
+	
+	public PickaxeToolItem(String name, String namespaceId, int id, ToolMaterial enumtoolmaterial) {
+		super(name, namespaceId, id, 2, enumtoolmaterial, BlockTags.MINEABLE_BY_PICKAXE);
+	}
+
+	@Override
+	public boolean canHarvestBlock(Mob entityLiving, ItemStack itemStack, Block block)
+	{
+		Integer miningLevel = miningLevels.get(block);
+		if(miningLevel != null) return material.getMiningLevel() >= miningLevel;
+		
+		return block.hasTag(BlockTags.MINEABLE_BY_PICKAXE);
+	}
+}
